Attribute VB_Name = "modFunctions"
Option Explicit
Public Type W2Score
  UnitsMade     As Long
  UnitsKilled   As Long
  UnitsLost     As Long
  StructsMade   As Long
  StructsKilled As Long
  StructsLost   As Long
  Gold          As Long
  Lumber        As Long
  Oil           As Long
  Spent         As Long
End Type
Private Declare Function GetPrivateProfileStringA Lib "kernel32" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileStringA Lib "kernel32" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
Public Declare Sub RtlMoveMemory Lib "kernel32" (lpvDest As Any, lpvSource As Any, ByVal cbCopy As Long)
Public Declare Function GetTickCount Lib "kernel32" () As Long
Public Function ReadINI(ByVal riSection As String, ByVal riKey As String, ByVal riDefault As String, ByVal riFile As String) As String
Dim sRiBuffer As String
Dim sRiValue  As String
Dim sRiLong   As String
Dim INIFile   As String
    INIFile = App.Path & "\" & riFile
    If LenB(Dir$(INIFile)) > 0 Then
        sRiBuffer = String$(255, vbNull)
        sRiLong = GetPrivateProfileStringA(riSection, riKey, ChrW$(1), sRiBuffer, 255, INIFile)
        If Left$(sRiBuffer, 1) <> ChrW$(1) Then
            sRiValue = Left$(sRiBuffer, sRiLong)
            If LenB(sRiValue) > 0 Then
                ReadINI = sRiValue
            Else
                ReadINI = riDefault
            End If
        Else
            ReadINI = riDefault
        End If
    Else
        ReadINI = riDefault
    End If
End Function
Public Sub WriteINI(ByVal wiSection As String, ByVal wiKey As String, ByVal wiValue As String, ByVal wiFile As String)
    WritePrivateProfileStringA wiSection, wiKey, wiValue, App.Path & "\" & wiFile
End Sub
Public Sub CreateServerList()
Dim nFile As Integer
  nFile = FreeFile
  Open App.Path & "\servers.ini" For Output As nFile
  Print #nFile, ";You may add or edit any of these connections."
  Print #nFile, ";The connection name is listed in brackets,"
  Print #nFile, ";and all data below is used as the connection IP."
  Print #nFile, "[uswest.battle.net]"
  Print #nFile, "12.129.236.14"
  Print #nFile, "12.129.236.15"
  Print #nFile, "12.129.236.16"
  Print #nFile, "12.129.236.17"
  Print #nFile, "12.129.236.18"
  Print #nFile, "12.129.236.19"
  Print #nFile, "12.129.236.20"
  Print #nFile, "12.129.236.22"
  Print #nFile, "12.129.236.11"
  Print #nFile, "12.129.236.12"
  Print #nFile, "12.129.236.13"
  Print #nFile, ""
  Print #nFile, "[useast.battle.net]"
  Print #nFile, "206.17.175.121"
  Print #nFile, "206.17.175.122"
  Print #nFile, "206.17.175.126"
  Print #nFile, "206.17.175.127"
  Print #nFile, "206.17.175.128"
  Print #nFile, "206.17.175.129"
  Print #nFile, "206.17.175.130"
  Print #nFile, "206.17.175.131"
  Print #nFile, "206.17.175.134"
  Print #nFile, "206.17.175.138"
  Print #nFile, "206.17.175.139"
  Print #nFile, "206.17.175.120"
  Print #nFile, ""
  Print #nFile, "[europe.battle.net]"
  Print #nFile, "213.248.115.16"
  Print #nFile, "213.248.115.17"
  Print #nFile, "213.248.115.18"
  Print #nFile, "213.248.115.11"
  Print #nFile, "213.248.115.12"
  Print #nFile, "213.248.115.13"
  Print #nFile, "213.248.115.14"
  Print #nFile, "213.248.115.15"
  Print #nFile, ""
  Print #nFile, "[asia.battle.net]"
  Print #nFile, "211.233.0.52"
  Print #nFile, "211.233.0.53"
  Print #nFile, "211.233.0.54"
  Print #nFile, "211.233.0.55"
  Print #nFile, "211.233.0.56"
  Print #nFile, "211.233.0.57"
  Print #nFile, "211.233.0.58"
  Print #nFile, "211.233.0.59"
  Print #nFile, "211.233.0.60"
  Print #nFile, "211.233.0.61"
  Print #nFile, "211.233.0.62"
  Print #nFile, "211.233.0.63"
  Print #nFile, "211.233.0.64"
  Print #nFile, "211.233.0.72"
  Print #nFile, "211.233.0.73"
  Print #nFile, "211.233.0.74"
  Print #nFile, "211.233.0.75"
  Print #nFile, "211.233.0.76"
  Print #nFile, "211.233.0.78"
  Print #nFile, "211.233.0.79"
  Print #nFile, "211.233.0.80"
  Print #nFile, "211.233.0.49"
  Print #nFile, "211.233.0.50"
  Print #nFile, "211.233.0.51"
  Close #nFile
End Sub
Public Function ConvertTime(ByVal lMS As Long, Optional ByVal Abbreviated As Boolean = False, Optional ByVal Hide0 As Boolean = False) As String
Dim lSeconds As Long
Dim lDays    As Long
Dim lHours   As Long
Dim lMins    As Long
Dim sSeconds As String
Dim sDays    As String
Dim sHours   As String
Dim sMins    As String
  lSeconds = lMS
  lDays = lSeconds \ 86400
  lSeconds = lSeconds Mod 86400
  lHours = lSeconds \ 3600
  lSeconds = lSeconds Mod 3600
  lMins = lSeconds \ 60
  lSeconds = lSeconds Mod 60
  If Abbreviated Then
    sDays = " d"
    sHours = " h"
    sMins = " m"
    sSeconds = " s"
  Else
    sDays = " day"
    sHours = " hr"
    sMins = " min"
    sSeconds = " sec"
    If lDays <> 1 Then sDays = sDays & "s"
    If lHours <> 1 Then sHours = sHours & "s"
    If lMins <> 1 Then sMins = sMins & "s"
    If lSeconds <> 1 Then sSeconds = sSeconds & "s"
  End If
  If Hide0 Then
    If lDays > 0 Then ConvertTime = lDays & sDays
    If lHours > 0 Then
      If LenB(ConvertTime) > 0 Then
        ConvertTime = ConvertTime & ", " & lHours & sHours
      Else
        ConvertTime = lHours & sHours
      End If
    End If
    If lMins > 0 Then
      If LenB(ConvertTime) > 0 Then
        ConvertTime = ConvertTime & ", " & lMins & sMins
      Else
        ConvertTime = lMins & sMins
      End If
    End If
    If lSeconds > 0 Then
      If LenB(ConvertTime) > 0 Then
        ConvertTime = ConvertTime & ", and " & lSeconds & sSeconds
      Else
        ConvertTime = lSeconds & sSeconds
      End If
    End If
  Else
    If lDays > 0 Then
      ConvertTime = lDays & sDays & ", " & lHours & sHours & ", " & lMins & sMins & ", and " & lSeconds & sSeconds
    ElseIf lHours > 0 Then
      ConvertTime = lHours & sHours & ", " & lMins & sMins & ", and " & lSeconds & sSeconds
    ElseIf lMins > 0 Then
      ConvertTime = lMins & sMins & " and " & lSeconds & sSeconds
    Else
      ConvertTime = lSeconds & sSeconds
    End If
  End If
End Function
Public Function HtS(ByVal HexToStr As String) As String
Dim strTemp   As String
Dim strReturn As String
Dim I         As Long
  For I = 1 To Len(HexToStr) Step 2
    strTemp = Chr$(Val("&H" & Mid$(HexToStr, I, 2)))
    strReturn = strReturn & strTemp
  Next I
  HtS = strReturn
End Function
